%% ------  Lezione6, 14 novembre 2016 ------ 
% K-NN: implementazione

clear all; % cancella il contenuto di memoria
close all; % cancella tutte le figure presenti nella sessione
clc; % pulisce lo schermo

load dataset
% Features sulle righe = 2 feature
% Oggetti sulle colonne = 99 oggetti di train, 51 di test

K = 5;

%% Idea: 
% Devo classificare ogni dato di test, quindi predirne l'etichetta:
% ciclo for sugli oggetti di test

for i = 1:length(labels_test)
    
    current = data_test(:,i);
    
    % Per ogni oggetto di test, calcolo la distanza euclidea con tutti
    % quelli di train --> vettore di 99 elementi
    for j = 1:length(labels_train)
        dist(j) = sqrt(sum( (current-data_train(:,j)) .^2 ));
    end
    
    % Ordino le distanze dalla più piccola alla più grande e trovo gli
    % indici dei K oggetti più vicini
    [val, idx] = sort(dist, 'ascend');
    
    % Prendo le etichette dei K oggetti più vicini e ne faccio la moda
    % (si veda help mode)
    etichette_K = labels_train(idx(1:K));
    predicted(i) = mode(etichette_K);
    
end

accuratezza = sum(predicted == labels_test) ./ length(labels_test)


%% Esercizio 2
% Applico il K-NN ad un set di sequenze proteiche

load sequences.mat

for i = 1:length(labels_test)
    
    current = data_test{i};
    
    % Per ogni sequenza di test, calcolo la SIMILARITA' con tutte
    % quelle di train
    for j = 1:length(labels_train)
        sim(j) = swalign(current, data_train{j});
    end
    
    % Ordino le similarità dalla più grande e trovo gli
    % indici delle K sequenze più vicine
    [val, idx] = sort(sim, 'descend');
    
    % Prendo le etichette dei K oggetti più vicini e ne faccio la moda
    % (si veda help mode)
    etichette_K = labels_train(idx(1:K));
    predicted(i) = mode(etichette_K);
    
end

accuratezza = sum(predicted == labels_test) ./ length(labels_test)















